include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
axiom nat : Type[0].
axiom O : nat.
axiom S : nat -> nat.
axiom match_nat_type : \forall return_ : Type[0] . return_ -> (nat -> return_) -> nat -> return_.
axiom axiom_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (equal) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n).
definition eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
definition sym_eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) (case_S n) ((match_nat_type) (return_type) case_O case_S ((S)  n)) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((sym_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
definition pred : nat -> nat := \lambda n : nat. (match_nat_type) (nat) (O)  (\lambda p : nat. p) n.
definition pred_Sn : \forall (n:nat). (eq) (nat) n ((pred)  ((S)  n)) := \lambda n : nat. ((((((sym_eq_match_nat_type_S) (nat)) ((O) )) (\lambda p : nat. p)) (n)) (\lambda y : nat. (eq) (nat) n y)) (((refl) (nat)) (n)).
definition not_eq_S : \forall (n:nat). \forall (m:nat). ((Not)  ((eq) (nat) n m)) -> (Not)  ((eq) (nat) ((S)  n) ((S)  m)) := \lambda n : nat. \lambda m : nat. \lambda auto : (Not)  ((eq) (nat) n m). (((((not_to_not) ((eq) (nat) ((S)  n) ((S)  m))) ((eq) (nat) n m)) (\lambda auto' : (eq) (nat) ((S)  n) ((S)  m). (((((((rewrite_l) (nat)) (m)) (\lambda j__ : nat. (eq) (nat) j__ m)) (((refl) (nat)) (m))) (n)) (((((((rewrite_r) (nat)) ((pred)  ((S)  n))) (\lambda j__ : nat. (eq) (nat) m j__)) (((((((rewrite_r) (nat)) ((S)  m)) (\lambda j__ : nat. (eq) (nat) m ((pred)  j__))) ((pred_Sn) (m))) ((S)  n)) (auto'))) (n)) ((pred_Sn) (n)))))) (auto)).
